精华内容
下载资源
问答
  • 目前Ubuntu 12.04自带的GCC版本为4.6,遗憾的是在实际使用时,反而版本越高越好问题越多,所以,一旦遇到编译问题时最好先检查你下载的工程里的readme,默认的编译器版本是否为当前的安装版本,如果不是,就需注意很...

    目前Ubuntu 12.04自带的GCC版本为4.6,遗憾的是在实际使用时,反而版本越高越好问题越多,所以,一旦遇到编译问题时最好先检查你下载的工程里的readme,默认的编译器版本是否为当前的安装版本,如果不是,就需注意很可能是版本兼容问题(甚至你可能是第一个遇到此BUG的幸运者),初步调试后即可尝试降低版本测试。

    目前主流gcc版本有两个,一个是gcc4.4,一个是gcc最新版本(4.6),下文介绍这两个版本切换和安装方法。

    一、gcc最新版本安装

    root@ubuntu:~# apt-get install build-essential

    这里build-essential会自动安装最新版本的gcc,如果需要指定使用旧版本gcc,只能再次手动安装。

    二、gcc 4.4安装

    gcc 4.4是目前很多工程指定的一个版本,安装方法如下:

    root@ubuntu:~# apt-get install gcc-4.4 g++-4.4 g++-4.4-multilib gcc-4.4-multilib

    三、设置gcc版本切换

    1、手动切换

    设置后,使用时需手动进行切换选择。

    root@ubuntu:~# ls /usr/bin/gcc* -l

    lrwxrwxrwx 1 root root 21 Sep 18 04:42 /usr/bin/gcc -> /etc/alternatives/gcc

    -rwxr-xr-x 1 root root 224544 Apr 15 22:58 /usr/bin/gcc-4.4

    -rwxr-xr-x 1 root root 306200 Apr 15 19:45 /usr/bin/gcc-4.6

    root@ubuntu:~#update-alternatives --install /usr/bin/gcc gcc /usr/bin/gcc-4.4 50

    root@ubuntu:~#update-alternatives --install /usr/bin/g++ gcc /usr/bin/g++-4.4 50

    选择方法(根据编译器选择其一):

    root@ubuntu:~#update-alternatives --config gcc

    root@ubuntu:~#update-alternatives --config g++

    参考选择界面:

    root@ubuntu:~# update-alternatives --config g++

    There are 2 choices for the alternative g++ (providing /usr/bin/g++).

    Selection Path Priority Status

    ------------------------------------------------------------

    * 0 /usr/bin/g++-4.4 100 auto mode

    1 /usr/bin/g++-4.4 100 manual mode

    2 /usr/bin/g++-4.6 50 manual mode

    Press enter to keep the current choice[*], or type selection number: 2

    update-alternatives: using /usr/bin/g++-4.6 to provide /usr/bin/g++ (g++) in manual mode.

    root@ubuntu:~#

    2、设置优先级自动

    设置后,系统自动根据优先级选择,假设要设置gcc4.4优先于gcc4.6,设置方法如下:

    update-alternatives --install /usr/bin/g++ g++ /usr/bin/g++-4.4 100

    update-alternatives --install /usr/bin/g++ g++ /usr/bin/g++-4.6 50

    update-alternatives --install /usr/bin/gcc gcc /usr/bin/gcc-4.4 100

    update-alternatives --install /usr/bin/gcc gcc /usr/bin/gcc-4.6 50

    update-alternatives --install /usr/bin/cpp cpp-bin /usr/bin/cpp-4.4 100

    update-alternatives --install /usr/bin/cpp cpp-bin /usr/bin/cpp-4.6 50

    设置完成后,gcc自动切换为使用4.4版本,因为上面设置4.4优先级高于4.6

    四、查看生效的gcc版本

    gcc -v

    示例输出:

    root@ubuntu:~# gcc -v

    Using built-in specs.

    COLLECT_GCC=gcc

    COLLECT_LTO_WRAPPER=/usr/lib/gcc/i686-linux-gnu/4.6/lto-wrapper

    Target: i686-linux-gnu

    Configured with: ../src/configure -v --with-pkgversion='Ubuntu/Linaro 4.6.3-1ubuntu5' --with-bugurl=file:///usr/share/doc/gcc-4.6/README.Bugs --enable-languages=c,c++,fortran,objc,obj-c++ --prefix=/usr --program-suffix=-4.6 --enable-shared --enable-linker-build-id --with-system-zlib --libexecdir=/usr/lib --without-included-gettext --enable-threads=posix --with-gxx-include-dir=/usr/include/c++/4.6 --libdir=/usr/lib --enable-nls --with-sysroot=/ --enable-clocale=gnu --enable-libstdcxx-debug --enable-libstdcxx-time=yes --enable-gnu-unique-object --enable-plugin --enable-objc-gc --enable-targets=a

    展开全文
  • 详解Linux安装GCC

    2019-09-29 02:03:19
    本文以在Redhat Linux安装GCC4.1.2为例(因在项目开发过程中要求使用,没有用最新的GCC版本),介绍Linux安装GCC过程AD:51CTO学院:IT精品课程在线看!现在很多程序员都应用GCC,怎样才能更好的应用G...

    为你详解Linux安装GCC方法

    2009-12-11 14:05 佚名 博客园 字号:T | T
    一键收藏,随时查看,分享好友!

    现在很多程序员都应用GCC,怎样才能更好的应用GCC。本文以在Redhat Linux安装GCC4.1.2为例(因在项目开发过程中要求使用,没有用最新的GCC版本),介绍Linux安装GCC过程

    AD:51CTO学院:IT精品课程在线看!

    现在很多程序员都应用GCC,怎样才能更好的应用GCC。目前,GCC可以用来编译C/C++、FORTRAN、JAVA、OBJC、ADA等语言的程序,可根据需要选择安装支持的语言。本文以在Redhat Linux安装GCC4.1.2为例(因在项目开发过程中要求使用,没有用最新的GCC版本),介绍Linux安装GCC过程。

    安装之前,系统中必须要有cc或者gcc等编译器,并且是可用的,或者用环境变量CC指定系统上的编译器。如果系统上没有编译器,不能安装源代码形式的GCC 4.1.2。如果是这种情况,可以在网上找一个与你系统相适应的如RPM等二进制形式的GCC软件包来安装使用。本文介绍的是以源代码形式提供的GCC软件包的安装过程,软件包本身和其安装过程同样适用于其它Linux和Unix系统。

    系统上原来的GCC编译器可能是把gcc等命令文件、库文件、头文件等分别存放到系统中的不同目录下的。与此不同,现在GCC建议我们将一个版本的GCC安装在一个单独的目录下。这样做的好处是将来不需要它的时候可以方便地删除整个目录即可(因为GCC没有uninstall功能);缺点是在安装完成后要做一些设置工作才能使编译器工作正常。在本文中采用这个方案安装GCC 4.1.2,并且在安装完成后,仍然能够使用原来低版本的GCC编译器,即一个系统上可以同时存在并使用多个版本的GCC编译器。

    按照本文提供的步骤和设置选项,即使以前没有安装过GCC,也可以在系统上安装上一个可工作的新版本的GCC编译器。

    1. 下载

    在GCC网站上(http://gcc.gnu.org)或者通过网上搜索可以查找到下载资源。目前GCC的最新版本为 4.2.1。可供下载的文件一般有两种形式:gcc-4.1.2.tar.gz和gcc-4.1.2.tar.bz2,只是压缩格式不一样,内容完全一致,下载其中一种即可。

    2. 解压缩

    拷贝gcc-4.1.2.tar.bz2(我下载的压缩文件)到/usr/local/src(根据自己喜好选择)下,根据压缩格式,选择下面相应的一种方式解包(以下的“%”表示命令行提示符):

    % tar zxvf gcc-4.1.2.tar.gz
    或者
    % bzcat gcc-4.1.2.tar.bz2 | tar xvf -

    新生成的gcc-4.1.2这个目录被称为源目录,用${srcdir}表示它。以后在出现${srcdir}的地方,应该用真实的路径来替换它。用pwd命令可以查看当前路径。

    在${srcdir}/INSTALL目录下有详细的GCC安装说明,可用浏览器打开index.html阅读。

    3. 建立目标目录

    目标目录(用${objdir}表示)是用来存放编译结果的地方。GCC建议编译后的文件不要放在源目录${srcdir]中(虽然这样做也可以),最好单独存放在另外一个目录中,而且不能是${srcdir}的子目录。

    例如,可以这样建立一个叫 /usr/local/gcc-4.1.2的目标目录:

    % mkdir /usr/local/gcc-4.1.2
    % cd gcc-4.1.2

    以下的操作主要是在目标目录 ${objdir} 下进行。

    4. 配置

    配置的目的是决定将GCC编译器安装到什么地方(${destdir}),支持什么语言以及指定其它一些选项等。其中,${destdir}不能与${objdir}或${srcdir}目录相同。

    配置是通过执行${srcdir}下的configure来完成的。其命令格式为(记得用你的真实路径替换${destdir}):

    % ${srcdir}/configure --prefix=${destdir} [其它选项]

    例如,如果想将GCC 4.1.2安装到/usr/local/gcc-4.1.2目录下,则${destdir}就表示这个路径。

    在我的机器上,我是这样配置的:

    % ../gcc-4.1.2/configure --prefix=/usr/local/gcc-4.1.2 --enable-threads=posix --disable-checking --enable--long-long --host=i386-redhat-linux --with-system-zlib --enable-languages=c,c++,java

    将GCC安装在/usr/local/gcc-4.1.2目录下,支持C/C++和JAVA语言,其它选项参见GCC提供的帮助说明。

    5. 编译

    % make

    6. 安装

    执行下面的命令将编译好的库文件等拷贝到${destdir}目录中(根据你设定的路径,可能需要管理员的权限):

    % make install

    至此,GCC 4.1.2安装过程就完成了。

    7. 其它设置

    GCC 4.1.2的所有文件,包括命令文件(如gcc、g++)、库文件等都在${destdir}目录下分别存放,如命令文件放在bin目录下、库文件在 lib下、头文件在include下等。由于命令文件和库文件所在的目录还没有包含在相应的搜索路径内,所以必须要作适当的设置之后编译器才能顺利地找到并使用它们。

    7.1 gcc、g++、gcj的设置

    要想使用GCC 4.1.2的gcc等命令,简单的方法就是把它的路径${destdir}/bin放在环境变量PATH中。我不用这种方式,而是用符号连接的方式实现,这样做的好处是我仍然可以使用系统上原来的旧版本的GCC编译器。

    首先,查看原来的gcc所在的路径:

    % which gcc

    在我的系统上,上述命令显示:/usr/bin/gcc。因此,原来的gcc命令在/usr/bin目录下。我们可以把GCC 4.1.2中的gcc、g++、gcj等命令在/usr/bin目录下分别做一个符号连接:

    % cd /usr/bin
    % ln -s ${destdir}/bin/gcc gcc412
    % ln -s ${destdir}/bin/g++ g++412
    % ln -s ${destdir}/bin/gcj gcj412

    这样,就可以分别使用gcc412、g++412、gcj412来调用GCC 4.1.2的gcc、g++、gcj完成对C、C++、JAVA程序的编译了。同时,仍然能够使用旧版本的GCC编译器中的gcc、g++等命令。

    7.2 库路径的设置

    将${destdir}/lib路径添加到环境变量LD_LIBRARY_PATH中,例如,如果GCC 4.1.2安装在/usr/local/gcc-4.1.2目录下,在RH Linux下可以直接在命令行上执行
    % export LD_LIBRARY_PATH=/usr/local/gcc-4.1.2/lib

    最好添加到系统的配置文件中,这样就不必要每次都设置这个环境变量了,在文件$HOME/.bash_profile中添加下面两句:
    LD_LIBRARY_PATH=/usr/local/gcc-4.1.2/lib:$LD_LIBRARY_PATH
    export LD_LIBRARY_PATH

    重启系统设置生效,或者执行命令
    % source $HOME/.bash_profile

    8. 测试

    用新的编译命令(gcc412、g++412等)编译你以前的C、C++程序,检验新安装的GCC编译器是否能正常工作。

    完成了Linux安装GCC,之后你就能轻松地编辑了。

    转载于:https://www.cnblogs.com/woshitianma/p/3701887.html

    展开全文
  • Linux安装gcc

    千次阅读 2012-07-17 10:58:08
    本文以在Redhat Linux安装GCC4.1.2为例(因在项目开发过程中要求使用,没有用最新的GCC版本),介绍Linux安装GCC过程。 安装之前,系统中必须要有cc或者gcc等编译器,并且是可用的,或者用环境变量C

    现在很多程序员都应用GCC,怎样才能更好的应用GCC。目前,GCC可以用来编译C/C++、FORTRAN、JAVA、OBJC、ADA等语言的程序,可根据需要选择安装支持的语言。本文以在Redhat Linux安装GCC4.1.2为例(因在项目开发过程中要求使用,没有用最新的GCC版本),介绍Linux安装GCC过程。

    安装之前,系统中必须要有cc或者gcc等编译器,并且是可用的,或者用环境变量CC指定系统上的编译器。如果系统上没有编译器,不能安装源代码形式的GCC 4.1.2。如果是这种情况,可以在网上找一个与你系统相适应的如RPM等二进制形式的GCC软件包来安装使用。本文介绍的是以源代码形式提供的GCC软件包的安装过程,软件包本身和其安装过程同样适用于其它Linux和Unix系统。

    系统上原来的GCC编译器可能是把gcc等命令文件、库文件、头文件等分别存放到系统中的不同目录下的。与此不同,现在GCC建议我们将一个版本的GCC安装在一个单独的目录下。这样做的好处是将来不需要它的时候可以方便地删除整个目录即可(因为GCC没有uninstall功能);缺点是在安装完成后要做一些设置工作才能使编译器工作正常。在本文中采用这个方案安装GCC 4.1.2,并且在安装完成后,仍然能够使用原来低版本的GCC编译器,即一个系统上可以同时存在并使用多个版本的GCC编译器。

    按照本文提供的步骤和设置选项,即使以前没有安装过GCC,也可以在系统上安装上一个可工作的新版本的GCC编译器。

    1 下载

    在GCC网站上(http://gcc.gnu.org)或者通过网上搜索可以查找到下载资源。目前GCC的最新版本为 4.2.1。可供下载的文件一般有两种形式:gcc-4.1.2.tar.gz和gcc-4.1.2.tar.bz2,只是压缩格式不一样,内容完全一致,下载其中一种即可。

    2. 解压缩

    拷贝gcc-4.1.2.tar.bz2(我下载的压缩文件)到/usr/local/src(根据自己喜好选择)下,根据压缩格式,选择下面相应的一种方式解包(以下的“%”表示命令行提示符):

    % tar zxvf gcc-4.1.2.tar.gz

    或者

    % bzcat gcc-4.1.2.tar.bz2 | tar xvf -

    新生成的gcc-4.1.2这个目录被称为源目录,用${srcdir}表示它。以后在出现${srcdir}的地方,应该用真实的路径来替换它。用pwd命令可以查看当前路径。

    在${srcdir}/INSTALL目录下有详细的GCC安装说明,可用浏览器打开index.html阅读。

    3. 建立目标目录

    目标目录(用${objdir}表示)是用来存放编译结果的地方。GCC建议编译后的文件不要放在源目录${srcdir]中(虽然这样做也可以),最好单独存放在另外一个目录中,而且不能是${srcdir}的子目录。

    例如,可以这样建立一个叫 /usr/local/gcc-4.1.2的目标目录:

    % mkdir /usr/local/gcc-4.1.2

    % cd gcc-4.1.2

    以下的操作主要是在目标目录 ${objdir} 下进行。(否则会出错,后面有解释)

    4. 配置

    配置的目的是决定将GCC编译器安装到什么地方(${destdir}),支持什么语言以及指定其它一些选项等。其中,${destdir}不能与${objdir}或${srcdir}目录相同。

    配置是通过执行${srcdir}下的configure来完成的。其命令格式为(记得用你的真实路径替换${destdir}):

    % ${srcdir}/configure --prefix=${destdir} [其它选项]

    例如,如果想将GCC 4.1.2安装到/usr/local/gcc-4.1.2目录下,则${destdir}就表示这个路径。

    在我的机器上,我是这样配置的:

    % ../gcc-4.1.2/configure --prefix=/usr/local/gcc-4.1.2 --enable-threads=posix --disable-checking --enable--long-long --host=i386-redhat-linux--with-system-zlib --enable-languages=c,c++,java

    将GCC安装在/usr/local/gcc-4.1.2目录下,支持C/C++和JAVA语言,其它选项参见GCC提供的帮助说明。

    5. 编译

    % make

    6. 安装

    执行下面的命令将编译好的库文件等拷贝到${destdir}目录中(根据你设定的路径,可能需要管理员的权限):

    % make install

    至此,GCC 4.1.2安装过程就完成了。

    7. 其它设置

    GCC 4.1.2的所有文件,包括命令文件(如gcc、g++)、库文件等都在${destdir}目录下分别存放,如命令文件放在bin目录下、库文件在 lib下、头文件在include下等。由于命令文件和库文件所在的目录还没有包含在相应的搜索路径内,所以必须要作适当的设置之后编译器才能顺利地找到并使用它们。

    7.1 gcc、g++、gcj的设置

    要想使用GCC 4.1.2的gcc等命令,简单的方法就是把它的路径${destdir}/bin放在环境变量PATH中。我不用这种方式,而是用符号连接的方式实现,这样做的好处是我仍然可以使用系统上原来的旧版本的GCC编译器。

    首先,查看原来的gcc所在的路径:

    % which gcc

    在我的系统上,上述命令显示:/usr/bin/gcc。因此,原来的gcc命令在/usr/bin目录下。我们可以把GCC 4.1.2中的gcc、g++、gcj等命令在/usr/bin目录下分别做一个符号连接:

    % cd /usr/bin

    % ln -s ${destdir}/bin/gcc gcc412

    % ln -s ${destdir}/bin/g++ g++412

    % ln -s ${destdir}/bin/gcj gcj412

    这样,就可以分别使用gcc412、g++412、gcj412来调用GCC 4.1.2的gcc、g++、gcj完成对C、C++、JAVA程序的编译了。同时,仍然能够使用旧版本的GCC编译器中的gcc、g++等命令。

    (cool,我感觉棒极了!!1)

    7.2 库路径的设置

    将${destdir}/lib路径添加到环境变量LD_LIBRARY_PATH中,例如,如果GCC 4.1.2安装在/usr/local/gcc-4.1.2目录下,在RH Linux下可以直接在命令行上执行

    % export LD_LIBRARY_PATH=/usr/local/gcc-4.1.2/lib

    最好添加到系统的配置文件中,这样就不必要每次都设置这个环境变量了,在文件$HOME/.bash_profile中添加下面两句:

    LD_LIBRARY_PATH=/usr/local/gcc-4.1.2/lib:$LD_LIBRARY_PATH

    export LD_LIBRARY_PATH

    重启系统设置生效,或者执行命令

    % source $HOME/.bash_profile

    用新的编译命令(gcc412、g++412等)编译你以前的C、C++程序,检验新安装的GCC编译器是否能正常工作。

    完成了Linux安装GCC,之后你就能轻松地编辑了。

    from:os.51cto.com/art/200912/168804.htm

    在RHLinux下安装gcc-4.0.1方法比较简单,但是安装过程中有些环节是需要注意的,否则,可能会导致安装不成功,或者安装报错。具体安装过程如下:

    首先,下载并解压缩gcc的RPM包至源目录(如/opt/gcc-4.0.1)

    1、解压缩RPM包:

    [root@linuxopt]# tar xjvf gcc-4.0.1.tar.bz2 (解压后生成源目录/opt/gcc-4.0.1)

    2、创建安装目标目录:

    [root@linux opt]# mkdir /usr/local/gcc-4.0.1/

    3、进入安装目标目录:

    [root@linux opt]# cd /usr/local/gcc-4.0.1/ (这一步很重要,配置安装文件时,需要在目标目录下执行configure命令)

    [root@linux opt]# pwd

    /usr/local/gcc-4.0.1

    4、配置安装文件:

    [root@linux gcc-4.0.1]# /opt/gcc-4.0.1/configure --prefix=/usr/local/gcc-4.0.1/ (这一步非常重要,需要在安装的目标目录下,执行源目录 /opt/gcc-4.0.1/中的configure命令,配置将gcc安装到目标目录/usr/local/gcc-4.0.1/)

    creating cache ./config.cache

    checking host system type... i686-pc-linux-gnu

    5、编译安装文件:

    [root@linux gcc-4.0.1]# pwd

    /usr/local/gcc-4.0.1

    [root@linux gcc-4.0.1]# make (在目标目录下执行编译)

    6、安装gcc:

    [root@linux gcc-4.0.1]# pwd

    /usr/local/gcc-4.0.1

    [root@linux gcc-4.0.1]# make install (在目标目录下执行安装)

    如果安装过程中步骤和命令没有错误,你肯定能安装成功。

    ---------------------------------------------------------------------

      首先,现在最新的包GCC 4.2.bz2,一般的到处都有的下,linux下的下载速度很满,20多k,很恶心,我喜欢迅雷的下载速度,在windows下下载,大概42M,下载速度2到4M,回到linux下,挂载,ntfs格式的我的,具体不说了,说安装!

      进入到挂载的目录下,先cp GCC4.2.bz2 /azuo,

      cd /azuo,

      tar -xvf GCC 4.2.bz2 ,

      得到gcc-4.2,

      cd gcc-4.2,在/usr目录下建立一个文件夹就是现在要存放新的gcc的目录,

      mkdir /usr/gcc4

      ./configure –prefix=/usr/gcc4

      回车,就会有配置信息,只要不报错就可以了,

      make,这个过程很久,因为我没有设置一些具体的选项,因此,所有的组件几乎都要编译一遍,我的电脑cpu:AMD 3200+X2 ,1.5g内存,大概花费一个半小时。

      到这个时候为止,/usr/gcc4下还没有任何东西,编译过程都是发生在源文件夹,让我们再来一个动作,所有的要用到的东西都会配置到目标文件夹下,

      make install;

      这个过程也不短,等着就是了。

      一切都已经弄好了之后就是使用最新的gcc了,可以看到,在/usr/gcc4/bin下有gcc,g++,等一些东西,都是可以用的,写两个程序:

      aa.c:

      1 #include

      2

      3 int main(void) {

      4 printf("ad");

      5 return 1;

      6 }

      gcc -o aa aa.c

      执行 ./aa

      上面的这个是c的,下面这个就是c++的了:

      a.cpp:

      1 #include

      2 using namespace std;

      3 int main(void) {

      4 cout << "Ok!" << endl;

      5 return 1;

      6 }

      g++ -o a a.cpp

      执行就是了./a

      一切ok了,就可以让最新的gcc工具取代原来的工具了。

      看看原来的gcc是什么版本的,我们好卸载它:

      [root@BTazuo bin]# rpm -qa gcc

      gcc-4.1.2-27.fc7

      [root@BTazuo bin]# rpm -e gcc-4.1.2-27.fc7

      error: Failed dependencies:

      gcc is needed by (installed) systemtap-0.5.13-1.fc7.i386

      gcc = 4.1.2-27.fc7 is needed by (installed) gcc-c++-4.1.2-27.fc7.i386

      gcc = 4.1.2-27.fc7 is needed by (installed) gcc-gfortran- 4.1.2 -27.fc7. i386

      [root@BTazuo bin]# rpm -e gcc-c++-4.1.2-27.fc7.i386

      [root@BTazuo bin]# rpm -e gcc-gfortran-4.1.2-27.fc7.i386

      [root@BTazuo bin]# rpm -e gcc-4.1.2-27.fc7

      error: Failed dependencies:

      gcc is needed by (installed) systemtap-0.5.13-1.fc7.i386

      [root@BTazuo bin]# g++

      bash: g++: command not found

      卸载成功

      [root@BTazuo bin]# gcc

      gcc: 没有输入文件 ,可见gcc犹在

      [root@BTazuo bin]# rpm -e systemtap-0.5.13-1.fc7.i386

      [root@BTazuo bin]# gcc

      gcc: 没有输入文件

      [root@BTazuo bin]# rpm -e gcc-4.1.2-27.fc7

      [root@BTazuo bin]# gcc

      bash: /usr/lib/ccache/gcc: 没有那个文件或目录

      最后的卸载成功!

      这个时候,要注意了,我的gcc在/usr/bin下面有,在/usr/lib/ccache这个目录下也有,分别在这两个下面都要建立一个链接:

      [root@BTazuo bin]# ln -s /usr/gcc4/bin/g++ g++

      [root@BTazuo bin]# g++

      g++: 没有输入文件

      可见g++已经装好了,可以使用了。

      然后是gcc:

      [root@BTazuo bin]# ln -s /usr/gcc4/bin/gcc gcc

      [root@BTazuo bin]# gcc

      bash: /usr/lib/ccache/gcc: 没有那个文件或目录

      [root@BTazuo bin]# ./gcc

      gcc: 没有输入文件

      可见还要给另外一个目录建立一个gcc的链接:

      [root@BTazuo lib]# ln -s /usr/gcc4/bin/gcc /usr/lib/ccache/gcc

      [root@BTazuo lib]# gcc

      gcc: 没有输入文件

      到此为止,gcc和g++都已经建立好了,可以用了,最后把原来的包和解压文件都可以删除了,以节省硬盘空间!

    -------------------------------------------------------------------------------------------------------

    下面介绍其在Red Hat Linux 9.0编译器给gcc 3.2.2环境下的安装方法。
    一.确定安装环境
    本安装方法适用于Red Hat Linux 9.0操作系统,自带的GCC编译器是GCC 3.2.2版本。其他系列的linux操作系统或是其他版本GCC下安装过程可能有些细节上的不同。
    注:因为不同版本的GCC编译器下一些库的定义可能有不同,因此首先要确定一下本机的GCC编译器版本。确定方法是进入命令行输入命令gcc –v得到的结果如图1.1所示:


    图1.1
    可见本机的GCC版本为GCC 3.2.2,根据simplescalar网站上的一些介绍,该模拟器的开发工具可能是GCC2.7左右,比较接近GCC 3.2.2,因此估计安装过程会比较顺利。
    二.获得安装包
    完成本安装过程的安装包可以在

    http://www.simplescalar.com
    下下载,本安装所需要的安装包共有以下三个

    三 建立安装目录,解压安装包
    建立安装目录为/root/simplescalar,将安装包复制到安装目录,整个过程如下:

    解压缩,命令为tar –zxvf,加压缩完毕后用rm*.tgz命令删除压缩包,整个过程输入命令如下:
    tar –zxvf simplesim-3v0d.tgz
    tar –zxvf simpletools-2v0.tgz
    tar –zxvf simpleutils-2v0.tgz
    rm*.tgz
    加压缩后得到如下七个文件夹:

    四.安装binutils2.5.2
    首先用configure命令配置程序的安装环境和参数,生成Makefile文件,整个过程如下:

    注:configure命令的参数含义说明
    -host:配置安装环境
    -target:配置成littleEndian模式
    -with-gnu-as 加载汇编器
    -with-gnu-ld 加载链接器
    -prefix 设置安装目录
    此时遇到两个错误,如下所示:


    从错误说明可以估计出错误来自于libiberty文件夹下的dummy.c文件。网上一些帖子说是dummy.c中定义的宏functions.def文件中的函数定义与声明不一致引起的,将它们改成一致就可以通过编译。但是这样做的话,继续编译依然会遇到许多错误。这里我试出了最好的方法就是将dummy.c文件中的内容全部删除(即将dummy.c变成空文件)然后再make一次,这回不报任何错误,编译一次通过!
    运行make install命令,这时binutils-2.5.2安装成功!
    五.安装simplescalar
    Simplescalar是最简单的一个安装过程,运行下列命令即可完成安装!


    六.安装gcc-2.6.3
    安装好simplescalar后在安装文件夹/root/simplescalar下可以找到一个名为bin的文件夹,里面包含的是一些simplescalar自带的工具,如链接工具等,该文件内容如下:


    可见,里面没有C编译工具gcc,因此还需要安装gcc2.6.3作为simplescalar的内置编译工具,下面介绍安装方法。
    首先对安装环境进行配置,生成Makefile文件,具体方法如下图所示。


    Makefile文件生成完毕后,运行make命令,此时出现以下错误:


    由错误报告可知,这是由于sys_errlist的定义不一致造成的,打开cccp.c文件发现其194行附近有如下代码,第194行为extern char *sys_errlist[]。显然要消除冲突,只需改变宏编译的分支方向,使其不走这一分支即可。尝试在这段代码前面如175行加上#define bsd4_4,修改后再次make,该错误改正,遇到下一个错误。


    第二个错误是sdbout.c文件中的一些常量没有定义,如下:



    因此第一估计是头文件的问题,打开sdbout.c发现其包含的头文件有如下几个:

    可以肯定报错的原因是宏编译的分支的问题(走不同的宏编译分支,可能包含syms.h或者是gsyms.h)。经过多次尝试,发现在前面加上#undef USG即可解决该错误(即把gsyms.h包含进去)。
    继续make,发生第三个错误,如下:


    这个错误和第一个错误一样,是由于sys_errlist定义冲突引起的,因此进入gcc.c文件,在172行之前(这里加在167行)加上#define bsd4_4即可。
    继续make,发生第四个错误,如下:


    和前面一样,只要在g++.c文件的第90行代码段之前(这里加在85行)加上#define bsd4_4即可。
    继续make,发生第五个错误,如下:


    这里提示是将cp/g++.c文件中第213行的sys_errlist改成strerror或者strerror_r,然而改过之后会报strerror未定义的错误,上网搜了很久也没发现有这两个定义的头文件名,最后根据函数名感觉这段代码(pfatal_with_name)的功能可能是获得错误名,将其删除估计对工作影响不大,因此干脆将这个函数放空,放空后再运行make,果然OK,不报任何错误,编译通过!
    运行make install,gcc 2.6.3安装成功!
    返回simplescalar,进入bin文件夹,可以发现里面多了一个sslittle-na-sstrix-gcc文件,该文件是simplescalar的内建C编译器,如下所示:


    进一步运行./sslittle-na-sstrix-gcc –v测试出该内建编译器版本为gcc 2.6.3。


    到此为止,整个安装过程结束,下面进行测试。
    七.测试
    为了测试simplescalar是否能够顺利运行,我们对其进行测试,测试程序依然采用最经典的hello world!程序,程序如下:
    #include
    main()
    {
    printf("Hello World!\n");
    return 0;
    }
    编辑好程序后将其保存在/root/simplescalar文件夹下,文件名为hello.c,用刚刚安装的simplescalar内建编译器编译,编译方法如下。


    运行结果如下:


    八 结束语
    本安装方法适用于Red Hat Linux 9.0操作系统,自带的GCC编译器是GCC 3.2.2版本。其他系列的linux操作系统或是其他版本GCC下安装过程可能有些细节上的不同,主要原因可能是高版本的GCC没有兼容低版本的一些库文件,还有就是遵循的C标准可能会有点出入。如果机器上的GCC正好是低版本的,估计可能一次编译通过!
    -----------------------------------------------------------------------------------------------------

      1. 下载
      在GCC网站上(
    http://gcc.gnu.org/
    )或通过网上搜索能查找到下载资源。目前GC
    C的最新版本为3.4.0。可供下载的文件一般有两种形式:gcc-3.4.0.tar.gz和gcc-3.4.0.tar.bz2,
    只是压缩格式不相同,内容完全一致,下载其中一种即可。
      2. 解压缩
      根据压缩格式,选择下面相应的一种方式解包(以下的"%"表示命令行提示符):
      % tar xzvf gcc-3.4.0.tar.gz

    % bzcat gcc-3.4.0.tar.bz2 | tar xvf -
      新生成的gcc-3.4.0这个目录被称为源目录,用${srcdir}表示他。以后在出现${srcdir
    }的地方,应该用真实的路径来替换他。用pwd命令能查看当前路径。
      在${srcdir}/INSTALL目录下有周详的GCC安装说明,可用浏览器打开index.html阅读。
      3. 建立目标目录
      目标目录(用${objdir}表示)是用来存放编译结果的地方。GCC建议编译后的文件不要
    放在源目录${srcdir]中(虽然这样做也能),最佳独立存放在另外一个目录中,而且不
    能是${srcdir}的子目录。
      例如,能这样建立一个叫 gcc-build
    的目标目录(和源目录${srcdir}是同级目录):
      % mkdir gcc-build
    % cd gcc-build
      以下的操作主要是在目标目录 ${objdir} 下进行。
      4. 设置
      设置的目的是决定将GCC编译器安装到什么地方(${destdir}),支持什么语言及指
    定其他一些选项等。其中,${destdir}不能和${objdir}或${srcdir}目录相同。
      设置是通过执行${srcdir}下的configure来完成的。其命令格式为(记得用你的真实路
    径替换${destdir}):
      % ${srcdir}/configure --prefix=${destdir} [其他选项]
      例如,如果想将GCC
    3.4.0安装到/usr/local/gcc-3.4.0目录下,则${destdir}就表示这个路径。
      在我的机器上,我是这样设置的:
      % ../gcc-3.4.0/configure --prefix=/usr/local/gcc-3.4.0
    --enable-threads=posix --disable-checking --enable--long-long
    --host=i386-redhat-linux --with-system-zlib --enable-languages=c,c++,java
      将GCC安装在/usr/local/gcc-3.4.0目录下,支持C/C++和JAVA语言,其他选项参见GCC
    提供的帮助说明。
      5. 编译
      % make
      这是个漫长的过程。在我的机器上(P4-1.6),这个过程用了50多分钟。
      6. 安装
      执行下面的命令将编译好的库文件等拷贝到${destdir}目录中(根据你设定的路径,可
    能需要管理员的权限):
      % make install
      至此,GCC 3.4.0安装过程就完成了。
      6. 其他设置
      GCC
    3.4.0的所有文件,包括命令文件(如gcc、g++)、库文件等都在${destdir}目录下分别存
    放,如命令文件放在bin目录下、库文件在lib下、头文件在include下等。由于命令文件和
    库文件所在的目录还没有包含在相应的搜索路径内,所以必须要作适当的设置之后编译器才
    能顺利地找到并使用他们。
      6.1 gcc、g++、gcj的设置
      要想使用GCC
    3.4.0的gcc等命令,简单的方法就是把他的路径${destdir}/bin放在环境变量PATH中。我不
    用这种方式,而是用符号连接的方式实现,这样做的好处是我仍然能使用系统上原来的旧
    版本的GCC编译器。
      首先,查看原来的gcc所在的路径:
      % which gcc
      在我的系统上,上述命令显示:/usr/bin/gcc。因此,原来的gcc命令在/usr/bin目录
    下。我们能把GCC
    3.4.0中的gcc、g++、gcj等命令在/usr/bin目录下分别做一个符号连接:
      % cd /usr/bin
    % ln -s ${destdir}/bin/gcc gcc34
    % ln -s ${destdir}/bin/g++ g++34
    % ln -s ${destdir}/bin/gcj gcj34
      这样,就能分别使用gcc34、g++34、gcj34来调用GCC
    3.4.0的gcc、g++、gcj完成对C、C++、JAVA程式的编译了。同时,仍然能够使用旧版本的GC
    C编译器中的gcc、g++等命令。
      6.2 库路径的设置
      将${destdir}/lib路径添加到环境变量LD_LIBRARY_PATH中,最佳添加到系统的设置文
    件中,这样就不必要每次都设置这个环境变量了。
      例如,如果GCC 3.4.0安装在/usr/local/gcc-3.4.0目录下,在RH
    Linux下能直接在命令行上执行或在文件/etc/profile中添加下面一句:
      setenv LD_LIBRARY_PATH /usr/local/gcc-3.4.0/lib:$LD_LIBRARY_PATH
      7. 测试
      用新的编译命令(gcc34、g++34等)编译你以前的C、C++程式,检验新安装的GCC编译
    器是否能正常工作。
      8. 根据需要,能删除或保留${srcdir}和${objdir}目录。 


    转载链接:http://www.cnblogs.com/chuncn/archive/2010/10/15/1851853.html

    展开全文
  • 最近想在CentOS release 6.10 (Final)上安装helib...= 5.4.0,需要安装新版本gcc 1. 下载安装适配版本的gmp, mpfr, mpc 基本都是 ./configure --prefix=/usr/local/gmp make make install 一定注意版本 mpfr安...

    最近想在CentOS release 6.10 (Final)上安装helib库,但是gcc版本太低并且没有cmake,而helib要求gcc版本>= 5.4.0,需要安装新版本gcc

    1. 下载安装适配版本的gmp, mpfr, mpc

    基本都是

    ./configure --prefix=/usr/local/gmp
    make
    make install

    一定注意版本

    mpfr安装时可能报错,做修改

    如果报错:mul.c:175:1: error: conflicting types for ‘mpfr_fmma’

    则将 mpc/src/mul.c中的 mpfr_fmma函数改名为mpfr_fmma_mul,一共三处

    2. 编译gcc,我的配置是这样的

    ../gcc-7.5.0/configure --prefix=/usr/local/gcc --enable-threads=posix --enable-languages=c,c++ --with-gmp=/usr/local/gmp --with-mpfr=/usr/local/mpfr -with-mpc=/usr/local/mpc/ --with-isl=/usr/local/isl/ --disable-multilib

    make -j 8

    中间可能需要软链接gmp, mpfr, mpc到/usr/lib64下

    make install

    然后做软链接

    ln -sf /usr/local/gcc/bin/gcc /usr/bin/gcc
    
    ln -sf /usr/local/gcc/bin/c++ /usr/bin/c++
    
    ln -sf /usr/local/gcc/bin/g++ /usr/bin/g++
    
    ln -sf /usr/local/gcc/lib64/libstdc++.so.6.0.22 /usr/lib64/libstdc++.so.6
    
    

    3. 安装ntl库

    ./configure NATIVE=off

    make -j16

    make install 

    4. 安装helib,按照文档按照即可

    需要注释掉clock_gettime(src/timing.cpp)

    展开全文
  • linux安装GCC

    万次阅读 2017-10-25 15:21:51
    CentOS 6.6 升级GCC G++ (当前最新GCC/G++版本为v6.1.0) 没有便捷方式, yum update.... yum install  或者 添加yum 的 repo 文件 也不行, 只能更新到 4.4.7! then, 只能手动编译安装了,那么开始第一步...
  • arm-linux-gcc 4.4.3版本安装步骤 将压缩包arm-linux-gcc.tar.gz解压到arm-linux-gcc文件夹 tar zcvf arm-linux-gcc.tar.gz arm-linux-gcc 将创建目录 mkdir /home/linux/arm-linux-gcc 将解压后的文件拷贝到安装...
  • linux 安装gcc

    2015-05-15 16:28:56
    一、首先从GNU上下载GCC包,ftp://gcc.gnu.org/,我使用的是最新发布版本gcc-4.5.1.tat.gz, 1) tar zxvf gcc-4.5.1.tar.gz 2) cd gcc-4.5.1 3) ./congigure 此时会出现这样的错误:  gcc configure: error:...
  • 今天安装最新版本的redis6.0.9版本,发现make编译时候报错 后来查了下百度发现是gcc编译版本过低的问题导致的,下边就是升级gcc编译版本的命令: yum -y install centos-release-scl yum -y install devtoolset-9-gcc ...
  • 为了在Linux上使用c++17, 我安装gcc 8.2, 以下是安装步骤: 一、下载安装包 wget https://ftp.gnu.org/gnu/gcc/gcc-8.2.0/gcc-8.2.0.tar.gz wget https://ftp.gnu.org/gnu/gmp/gmp-4.3.2.tar.gz wget ...
  • 第一步:安装默认版本gcc 首先我们需要安装一个gcc,我们使用yum命令来进行安装。 $ yum install gcc $ yum install gcc-c++ 这两个命令步骤还是很快的。之后我们可以查看我们的gcc版本 $ gcc --...
  • 由于gcc在5.x版本修改了ABI,导致新版本gcc编译的二进制文件放在老的环境下会报错,所以需要安装gcc4.8.5。4.8.5这个版本支持c++11。首先尝试下载gcc-4.8.5的源码编译安装,结果make时报错“libstdc++.so.6: : ...
  • Linux安装gcc-6.1.0

    千次阅读 2016-08-07 20:12:31
    获取gcc源码包gcc版本地址:https://ftp.gnu.org/gnu/gcc 目前最新的是6.1.0版:https://ftp.gnu.org/gnu/gcc/gcc-6.1.0/gcc-6.1.0.tar.bz2# wget https://ftp.gnu.org/gnu/gcc/gcc-6.1.0/gcc-6.1.0.tar.bz2 # ...
  • linuxgcc安装

    万次阅读 2019-05-28 11:25:22
    linux一般可以从软件包等方式直接安装gcc,但不一般不是最新版,比如需要支持C++11 等原因,则需要安装最新版gcc。 先查看已有的gcc版本 如果系统还没有任何gcc被安装,则需要从开发包中先安装默认的低版本的...
  • 由于gcc在5.x版本修改了ABI,导致新版本gcc编译的二进制文件放在老的环境下会报错,所以需要安装gcc4.8.5。4.8.5这个版本支持c++11。首先尝试下载gcc-4.8.5的源码编译安装,结果make时报错“libstdc++.so.6: : ...
  • gcc新版本安装

    2015-08-06 10:14:47
    使用yum安装gcc对于配备了yum的Linux发行版而言,安装gcc编译器就变得so easy。我们只需要分别执行如下命令即可:#安装gcc、c++编译器以及内核文件yum -y install gcc gcc-c++ kernel-devel自行安装...
  • 删除原有的gcc链接, 改为连接 cd /usr/bin sudo rm gcc sudo ln -s /usr/bin/gcc-8 /usr/bin/gcc g++ 操作同上, 把gcc换成g++ 即可 可能出现的问题: g++ 已安装, 但是用g++ -v查看版本时却找不到, 具体报错...
  • 本文以在Redhat Linux安装GCC4.1.2为例(因在项目开发过程中要求使用,没有用最新的GCC版本),介绍Linux安装GCC过程。 安装之前,系统中必须要有cc或者gcc等编译器,并且是可用的,或者用环境变量CC指定系统上的...
  • Linux升级安装GCC

    2019-08-30 10:35:46
    各发行版本Linux中,其自带的gcc安装版本都比较旧,我所使用CentOS 6系统中,gcc版本只有4.4.7。最近要安装几个软件要求gcc 4.8+,无奈只能手动升级gcc。 1. 下载最新版本gcc gcc当前最新版本是5.2,下面是我...
  • 本文档讲解安装最新gcc工具,安装版本gcc-7.2.0,支持C11,适合Linux用户安装
  • 因为原生的CentOS 7自动安装gcc版本是4.8.5; yum -y install gcc gcc-c++ kernel-devel ...最近工作和学习中需要使用C++17,所以被迫安装新版本gcc编译器。   一、环境准备 yum -y install gmp-devel ...
  • Linux 升级安装gcc g++

    千次阅读 2017-03-01 18:44:35
    Linux 升级安装gcc g++ Linux 运行程序,出错提示如下,网上查找需要更新gcc ,g++ 版本为4.8以后的。 1. 下载最新版本gcc gcc当前最新版本是5.2,用迅雷下载: wget ...
  • Linuxgcc安装

    2019-04-06 20:18:22
    我们安装gcc版本可能太低,需要升级到较版本,才能安装编译一些别的插件 gcc 4.8 安装 [root@DS-VM-Node239 ~]# curl -Lks http://www.hop5.in/yum/el6/hop5.repo > /etc/yum.repos.d/hop5.repo [root@DS...
  • linux安装gcc

    2015-09-02 19:51:37
    linux安装gcc 2013年09月16日 ⁄ 综合 ⁄ 共 1593字 ⁄ 字号 小 中 大 ⁄ 评论关闭 一、首先从GNU上下载GCC包,ftp://gcc.gnu.org/,我使用的是最新发布版本gcc-4.5.1.tat.gz, 1) tar zxvf ...
  • linux下最新版gcc安装

    万次阅读 2018-10-09 21:21:06
    手动编译并安装gcc最新版本 提示:需要先有c编译器,和必要的c++库,否则后面会报错,可以等报错再回头看这里。  安装C编译器  $ yum install gcc //目前使用yum方式只能安装最高为4.8.5版本的  安装c++库 ...
  • Linux升级安装GCC g++

    千次阅读 2016-07-30 14:54:17
    各发行版本Linux中,其自带的gcc安装版本都比较旧,我所使用CentOS 6系统中,gcc版本只有4.4.7。最近要安装几个软件要求gcc 4.8+,无奈只能手动升级gcc。 1. 下载最新版本gcc gcc当前最新版本是5.2,下面...
  • 因业务需要源码编译mongodb4.2.x版本,根据mongodb编译要求gcc版本8.0以上,操作系统为centos7.x,因centos7 yum源升级gcc版本最新至4.8.5,所以需要手动源码安装gcc新版本,本文目标为安装gcc8.3.0。GCC源码下载...
  • 当然,http://ftp.gnu.org/gnu/gcc 里面有所有的gcc版本供下载,最新版本已经有4.9.2啦。下载供编译需求的依赖项,这个神奇的脚本文件会帮我们下载、配置、安装依赖库,可以节约我们大量的时间和精力。 cd gcc-...
  • LinuxGCC安装

    2012-12-19 16:45:33
    本文以在Redhat Linux安装GCC4.1.2为例(因在项目开发过程中要求使用,没有用最新的GCC版本),介绍Linux安装GCC过程。 安装之前,系统中必须要有cc或者gcc等编译器,并且是可用的,或者用环境变量C

空空如也

空空如也

1 2 3 4 5 ... 20
收藏数 941
精华内容 376
关键字:

linux安装gcc新版本

linux 订阅